Merge branch 'rs/t1002-do-not-use-sum'
[git/git.git] / t / test-lib.sh
1 # Test framework for git. See t/README for usage.
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see http://www.gnu.org/licenses/ .
17
18 # Test the binaries we have just built. The tests are kept in
19 # t/ subdirectory and are run in 'trash directory' subdirectory.
20 if test -z "$TEST_DIRECTORY"
21 then
22 # We allow tests to override this, in case they want to run tests
23 # outside of t/, e.g. for running tests on the test library
24 # itself.
25 TEST_DIRECTORY=$(pwd)
26 else
27 # ensure that TEST_DIRECTORY is an absolute path so that it
28 # is valid even if the current working directory is changed
29 TEST_DIRECTORY=$(cd "$TEST_DIRECTORY" && pwd) || exit 1
30 fi
31 if test -z "$TEST_OUTPUT_DIRECTORY"
32 then
33 # Similarly, override this to store the test-results subdir
34 # elsewhere
35 TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
36 fi
37 GIT_BUILD_DIR="$TEST_DIRECTORY"/..
38
39 # If we were built with ASAN, it may complain about leaks
40 # of program-lifetime variables. Disable it by default to lower
41 # the noise level. This needs to happen at the start of the script,
42 # before we even do our "did we build git yet" check (since we don't
43 # want that one to complain to stderr).
44 : ${ASAN_OPTIONS=detect_leaks=0:abort_on_error=1}
45 export ASAN_OPTIONS
46
47 ################################################################
48 # It appears that people try to run tests without building...
49 "$GIT_BUILD_DIR/git" >/dev/null
50 if test $? != 1
51 then
52 echo >&2 'error: you do not seem to have built git yet.'
53 exit 1
54 fi
55
56 . "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
57 export PERL_PATH SHELL_PATH
58
59 # if --tee was passed, write the output not only to the terminal, but
60 # additionally to the file test-results/$BASENAME.out, too.
61 case "$GIT_TEST_TEE_STARTED, $* " in
62 done,*)
63 # do not redirect again
64 ;;
65 *' --tee '*|*' --va'*|*' --verbose-log '*)
66 mkdir -p "$TEST_OUTPUT_DIRECTORY/test-results"
67 BASE="$TEST_OUTPUT_DIRECTORY/test-results/$(basename "$0" .sh)"
68
69 # Make this filename available to the sub-process in case it is using
70 # --verbose-log.
71 GIT_TEST_TEE_OUTPUT_FILE=$BASE.out
72 export GIT_TEST_TEE_OUTPUT_FILE
73
74 # Truncate before calling "tee -a" to get rid of the results
75 # from any previous runs.
76 >"$GIT_TEST_TEE_OUTPUT_FILE"
77
78 (GIT_TEST_TEE_STARTED=done ${SHELL_PATH} "$0" "$@" 2>&1;
79 echo $? >"$BASE.exit") | tee -a "$GIT_TEST_TEE_OUTPUT_FILE"
80 test "$(cat "$BASE.exit")" = 0
81 exit
82 ;;
83 esac
84
85 # For repeatability, reset the environment to known value.
86 # TERM is sanitized below, after saving color control sequences.
87 LANG=C
88 LC_ALL=C
89 PAGER=cat
90 TZ=UTC
91 export LANG LC_ALL PAGER TZ
92 EDITOR=:
93 # A call to "unset" with no arguments causes at least Solaris 10
94 # /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets
95 # deriving from the command substitution clustered with the other
96 # ones.
97 unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
98 my @env = keys %ENV;
99 my $ok = join("|", qw(
100 TRACE
101 DEBUG
102 TEST
103 .*_TEST
104 PROVE
105 VALGRIND
106 UNZIP
107 PERF_
108 CURL_VERBOSE
109 TRACE_CURL
110 ));
111 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
112 print join("\n", @vars);
113 ')
114 unset XDG_CONFIG_HOME
115 unset GITPERLLIB
116 GIT_AUTHOR_EMAIL=author@example.com
117 GIT_AUTHOR_NAME='A U Thor'
118 GIT_COMMITTER_EMAIL=committer@example.com
119 GIT_COMMITTER_NAME='C O Mitter'
120 GIT_MERGE_VERBOSITY=5
121 GIT_MERGE_AUTOEDIT=no
122 export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
123 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
124 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
125 export EDITOR
126
127 # Tests using GIT_TRACE typically don't want <timestamp> <file>:<line> output
128 GIT_TRACE_BARE=1
129 export GIT_TRACE_BARE
130
131 if test -n "${TEST_GIT_INDEX_VERSION:+isset}"
132 then
133 GIT_INDEX_VERSION="$TEST_GIT_INDEX_VERSION"
134 export GIT_INDEX_VERSION
135 fi
136
137 # Add libc MALLOC and MALLOC_PERTURB test
138 # only if we are not executing the test with valgrind
139 if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev/null ||
140 test -n "$TEST_NO_MALLOC_CHECK"
141 then
142 setup_malloc_check () {
143 : nothing
144 }
145 teardown_malloc_check () {
146 : nothing
147 }
148 else
149 setup_malloc_check () {
150 MALLOC_CHECK_=3 MALLOC_PERTURB_=165
151 export MALLOC_CHECK_ MALLOC_PERTURB_
152 }
153 teardown_malloc_check () {
154 unset MALLOC_CHECK_ MALLOC_PERTURB_
155 }
156 fi
157
158 # Protect ourselves from common misconfiguration to export
159 # CDPATH into the environment
160 unset CDPATH
161
162 unset GREP_OPTIONS
163 unset UNZIP
164
165 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
166 1|2|true)
167 GIT_TRACE=4
168 ;;
169 esac
170
171 # Convenience
172 #
173 # A regexp to match 5 and 40 hexdigits
174 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
175 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
176
177 # Zero SHA-1
178 _z40=0000000000000000000000000000000000000000
179
180 EMPTY_TREE=4b825dc642cb6eb9a060e54bf8d69288fbee4904
181 EMPTY_BLOB=e69de29bb2d1d6434b8b29ae775ad8c2e48c5391
182
183 # Line feed
184 LF='
185 '
186
187 # UTF-8 ZERO WIDTH NON-JOINER, which HFS+ ignores
188 # when case-folding filenames
189 u200c=$(printf '\342\200\214')
190
191 export _x05 _x40 _z40 LF u200c EMPTY_TREE EMPTY_BLOB
192
193 # Each test should start with something like this, after copyright notices:
194 #
195 # test_description='Description of this test...
196 # This test checks if command xyzzy does the right thing...
197 # '
198 # . ./test-lib.sh
199 test "x$TERM" != "xdumb" && (
200 test -t 1 &&
201 tput bold >/dev/null 2>&1 &&
202 tput setaf 1 >/dev/null 2>&1 &&
203 tput sgr0 >/dev/null 2>&1
204 ) &&
205 color=t
206
207 while test "$#" -ne 0
208 do
209 case "$1" in
210 -d|--d|--de|--deb|--debu|--debug)
211 debug=t; shift ;;
212 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
213 immediate=t; shift ;;
214 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
215 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
216 -r)
217 shift; test "$#" -ne 0 || {
218 echo 'error: -r requires an argument' >&2;
219 exit 1;
220 }
221 run_list=$1; shift ;;
222 --run=*)
223 run_list=${1#--*=}; shift ;;
224 -h|--h|--he|--hel|--help)
225 help=t; shift ;;
226 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
227 verbose=t; shift ;;
228 --verbose-only=*)
229 verbose_only=${1#--*=}
230 shift ;;
231 -q|--q|--qu|--qui|--quie|--quiet)
232 # Ignore --quiet under a TAP::Harness. Saying how many tests
233 # passed without the ok/not ok details is always an error.
234 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
235 --with-dashes)
236 with_dashes=t; shift ;;
237 --no-color)
238 color=; shift ;;
239 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
240 valgrind=memcheck
241 shift ;;
242 --valgrind=*)
243 valgrind=${1#--*=}
244 shift ;;
245 --valgrind-only=*)
246 valgrind_only=${1#--*=}
247 shift ;;
248 --tee)
249 shift ;; # was handled already
250 --root=*)
251 root=${1#--*=}
252 shift ;;
253 --chain-lint)
254 GIT_TEST_CHAIN_LINT=1
255 shift ;;
256 --no-chain-lint)
257 GIT_TEST_CHAIN_LINT=0
258 shift ;;
259 -x)
260 trace=t
261 verbose=t
262 shift ;;
263 --verbose-log)
264 verbose_log=t
265 shift ;;
266 *)
267 echo "error: unknown test option '$1'" >&2; exit 1 ;;
268 esac
269 done
270
271 if test -n "$valgrind_only"
272 then
273 test -z "$valgrind" && valgrind=memcheck
274 test -z "$verbose" && verbose_only="$valgrind_only"
275 elif test -n "$valgrind"
276 then
277 verbose=t
278 fi
279
280 if test -n "$color"
281 then
282 # Save the color control sequences now rather than run tput
283 # each time say_color() is called. This is done for two
284 # reasons:
285 # * TERM will be changed to dumb
286 # * HOME will be changed to a temporary directory and tput
287 # might need to read ~/.terminfo from the original HOME
288 # directory to get the control sequences
289 # Note: This approach assumes the control sequences don't end
290 # in a newline for any terminal of interest (command
291 # substitutions strip trailing newlines). Given that most
292 # (all?) terminals in common use are related to ECMA-48, this
293 # shouldn't be a problem.
294 say_color_error=$(tput bold; tput setaf 1) # bold red
295 say_color_skip=$(tput setaf 4) # blue
296 say_color_warn=$(tput setaf 3) # brown/yellow
297 say_color_pass=$(tput setaf 2) # green
298 say_color_info=$(tput setaf 6) # cyan
299 say_color_reset=$(tput sgr0)
300 say_color_="" # no formatting for normal text
301 say_color () {
302 test -z "$1" && test -n "$quiet" && return
303 eval "say_color_color=\$say_color_$1"
304 shift
305 printf "%s\\n" "$say_color_color$*$say_color_reset"
306 }
307 else
308 say_color() {
309 test -z "$1" && test -n "$quiet" && return
310 shift
311 printf "%s\n" "$*"
312 }
313 fi
314
315 TERM=dumb
316 export TERM
317
318 error () {
319 say_color error "error: $*"
320 GIT_EXIT_OK=t
321 exit 1
322 }
323
324 say () {
325 say_color info "$*"
326 }
327
328 if test -n "$HARNESS_ACTIVE"
329 then
330 if test "$verbose" = t || test -n "$verbose_only"
331 then
332 printf 'Bail out! %s\n' \
333 'verbose mode forbidden under TAP harness; try --verbose-log'
334 exit 1
335 fi
336 fi
337
338 test "${test_description}" != "" ||
339 error "Test script did not set test_description."
340
341 if test "$help" = "t"
342 then
343 printf '%s\n' "$test_description"
344 exit 0
345 fi
346
347 exec 5>&1
348 exec 6<&0
349 exec 7>&2
350 if test "$verbose_log" = "t"
351 then
352 exec 3>>"$GIT_TEST_TEE_OUTPUT_FILE" 4>&3
353 elif test "$verbose" = "t"
354 then
355 exec 4>&2 3>&1
356 else
357 exec 4>/dev/null 3>/dev/null
358 fi
359
360 # Send any "-x" output directly to stderr to avoid polluting tests
361 # which capture stderr. We can do this unconditionally since it
362 # has no effect if tracing isn't turned on.
363 #
364 # Note that this sets up the trace fd as soon as we assign the variable, so it
365 # must come after the creation of descriptor 4 above. Likewise, we must never
366 # unset this, as it has the side effect of closing descriptor 4, which we
367 # use to show verbose tests to the user.
368 #
369 # Note also that we don't need or want to export it. The tracing is local to
370 # this shell, and we would not want to influence any shells we exec.
371 BASH_XTRACEFD=4
372
373 test_failure=0
374 test_count=0
375 test_fixed=0
376 test_broken=0
377 test_success=0
378
379 test_external_has_tap=0
380
381 die () {
382 code=$?
383 if test -n "$GIT_EXIT_OK"
384 then
385 exit $code
386 else
387 echo >&5 "FATAL: Unexpected exit with code $code"
388 exit 1
389 fi
390 }
391
392 GIT_EXIT_OK=
393 trap 'die' EXIT
394 trap 'exit $?' INT
395
396 # The user-facing functions are loaded from a separate file so that
397 # test_perf subshells can have them too
398 . "$TEST_DIRECTORY/test-lib-functions.sh"
399
400 # You are not expected to call test_ok_ and test_failure_ directly, use
401 # the test_expect_* functions instead.
402
403 test_ok_ () {
404 test_success=$(($test_success + 1))
405 say_color "" "ok $test_count - $@"
406 }
407
408 test_failure_ () {
409 test_failure=$(($test_failure + 1))
410 say_color error "not ok $test_count - $1"
411 shift
412 printf '%s\n' "$*" | sed -e 's/^/# /'
413 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
414 }
415
416 test_known_broken_ok_ () {
417 test_fixed=$(($test_fixed+1))
418 say_color error "ok $test_count - $@ # TODO known breakage vanished"
419 }
420
421 test_known_broken_failure_ () {
422 test_broken=$(($test_broken+1))
423 say_color warn "not ok $test_count - $@ # TODO known breakage"
424 }
425
426 test_debug () {
427 test "$debug" = "" || eval "$1"
428 }
429
430 match_pattern_list () {
431 arg="$1"
432 shift
433 test -z "$*" && return 1
434 for pattern_
435 do
436 case "$arg" in
437 $pattern_)
438 return 0
439 esac
440 done
441 return 1
442 }
443
444 match_test_selector_list () {
445 title="$1"
446 shift
447 arg="$1"
448 shift
449 test -z "$1" && return 0
450
451 # Both commas and whitespace are accepted as separators.
452 OLDIFS=$IFS
453 IFS=' ,'
454 set -- $1
455 IFS=$OLDIFS
456
457 # If the first selector is negative we include by default.
458 include=
459 case "$1" in
460 !*) include=t ;;
461 esac
462
463 for selector
464 do
465 orig_selector=$selector
466
467 positive=t
468 case "$selector" in
469 !*)
470 positive=
471 selector=${selector##?}
472 ;;
473 esac
474
475 test -z "$selector" && continue
476
477 case "$selector" in
478 *-*)
479 if expr "z${selector%%-*}" : "z[0-9]*[^0-9]" >/dev/null
480 then
481 echo "error: $title: invalid non-numeric in range" \
482 "start: '$orig_selector'" >&2
483 exit 1
484 fi
485 if expr "z${selector#*-}" : "z[0-9]*[^0-9]" >/dev/null
486 then
487 echo "error: $title: invalid non-numeric in range" \
488 "end: '$orig_selector'" >&2
489 exit 1
490 fi
491 ;;
492 *)
493 if expr "z$selector" : "z[0-9]*[^0-9]" >/dev/null
494 then
495 echo "error: $title: invalid non-numeric in test" \
496 "selector: '$orig_selector'" >&2
497 exit 1
498 fi
499 esac
500
501 # Short cut for "obvious" cases
502 test -z "$include" && test -z "$positive" && continue
503 test -n "$include" && test -n "$positive" && continue
504
505 case "$selector" in
506 -*)
507 if test $arg -le ${selector#-}
508 then
509 include=$positive
510 fi
511 ;;
512 *-)
513 if test $arg -ge ${selector%-}
514 then
515 include=$positive
516 fi
517 ;;
518 *-*)
519 if test ${selector%%-*} -le $arg \
520 && test $arg -le ${selector#*-}
521 then
522 include=$positive
523 fi
524 ;;
525 *)
526 if test $arg -eq $selector
527 then
528 include=$positive
529 fi
530 ;;
531 esac
532 done
533
534 test -n "$include"
535 }
536
537 maybe_teardown_verbose () {
538 test -z "$verbose_only" && return
539 exec 4>/dev/null 3>/dev/null
540 verbose=
541 }
542
543 last_verbose=t
544 maybe_setup_verbose () {
545 test -z "$verbose_only" && return
546 if match_pattern_list $test_count $verbose_only
547 then
548 exec 4>&2 3>&1
549 # Emit a delimiting blank line when going from
550 # non-verbose to verbose. Within verbose mode the
551 # delimiter is printed by test_expect_*. The choice
552 # of the initial $last_verbose is such that before
553 # test 1, we do not print it.
554 test -z "$last_verbose" && echo >&3 ""
555 verbose=t
556 else
557 exec 4>/dev/null 3>/dev/null
558 verbose=
559 fi
560 last_verbose=$verbose
561 }
562
563 maybe_teardown_valgrind () {
564 test -z "$GIT_VALGRIND" && return
565 GIT_VALGRIND_ENABLED=
566 }
567
568 maybe_setup_valgrind () {
569 test -z "$GIT_VALGRIND" && return
570 if test -z "$valgrind_only"
571 then
572 GIT_VALGRIND_ENABLED=t
573 return
574 fi
575 GIT_VALGRIND_ENABLED=
576 if match_pattern_list $test_count $valgrind_only
577 then
578 GIT_VALGRIND_ENABLED=t
579 fi
580 }
581
582 want_trace () {
583 test "$trace" = t && test "$verbose" = t
584 }
585
586 # This is a separate function because some tests use
587 # "return" to end a test_expect_success block early
588 # (and we want to make sure we run any cleanup like
589 # "set +x").
590 test_eval_inner_ () {
591 # Do not add anything extra (including LF) after '$*'
592 eval "
593 want_trace && set -x
594 $*"
595 }
596
597 test_eval_ () {
598 # We run this block with stderr redirected to avoid extra cruft
599 # during a "-x" trace. Once in "set -x" mode, we cannot prevent
600 # the shell from printing the "set +x" to turn it off (nor the saving
601 # of $? before that). But we can make sure that the output goes to
602 # /dev/null.
603 #
604 # The test itself is run with stderr put back to &4 (so either to
605 # /dev/null, or to the original stderr if --verbose was used).
606 {
607 test_eval_inner_ "$@" </dev/null >&3 2>&4
608 test_eval_ret_=$?
609 if want_trace
610 then
611 set +x
612 if test "$test_eval_ret_" != 0
613 then
614 say_color error >&4 "error: last command exited with \$?=$test_eval_ret_"
615 fi
616 fi
617 } 2>/dev/null
618 return $test_eval_ret_
619 }
620
621 test_run_ () {
622 test_cleanup=:
623 expecting_failure=$2
624
625 if test "${GIT_TEST_CHAIN_LINT:-1}" != 0; then
626 # turn off tracing for this test-eval, as it simply creates
627 # confusing noise in the "-x" output
628 trace_tmp=$trace
629 trace=
630 # 117 is magic because it is unlikely to match the exit
631 # code of other programs
632 if test "OK-117" != "$(test_eval_ "(exit 117) && $1${LF}${LF}echo OK-\$?" 3>&1)"
633 then
634 error "bug in the test script: broken &&-chain or run-away HERE-DOC: $1"
635 fi
636 trace=$trace_tmp
637 fi
638
639 setup_malloc_check
640 test_eval_ "$1"
641 eval_ret=$?
642 teardown_malloc_check
643
644 if test -z "$immediate" || test $eval_ret = 0 ||
645 test -n "$expecting_failure" && test "$test_cleanup" != ":"
646 then
647 setup_malloc_check
648 test_eval_ "$test_cleanup"
649 teardown_malloc_check
650 fi
651 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
652 then
653 echo ""
654 fi
655 return "$eval_ret"
656 }
657
658 test_start_ () {
659 test_count=$(($test_count+1))
660 maybe_setup_verbose
661 maybe_setup_valgrind
662 }
663
664 test_finish_ () {
665 echo >&3 ""
666 maybe_teardown_valgrind
667 maybe_teardown_verbose
668 }
669
670 test_skip () {
671 to_skip=
672 skipped_reason=
673 if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
674 then
675 to_skip=t
676 skipped_reason="GIT_SKIP_TESTS"
677 fi
678 if test -z "$to_skip" && test -n "$test_prereq" &&
679 ! test_have_prereq "$test_prereq"
680 then
681 to_skip=t
682
683 of_prereq=
684 if test "$missing_prereq" != "$test_prereq"
685 then
686 of_prereq=" of $test_prereq"
687 fi
688 skipped_reason="missing $missing_prereq${of_prereq}"
689 fi
690 if test -z "$to_skip" && test -n "$run_list" &&
691 ! match_test_selector_list '--run' $test_count "$run_list"
692 then
693 to_skip=t
694 skipped_reason="--run"
695 fi
696
697 case "$to_skip" in
698 t)
699 say_color skip >&3 "skipping test: $@"
700 say_color skip "ok $test_count # skip $1 ($skipped_reason)"
701 : true
702 ;;
703 *)
704 false
705 ;;
706 esac
707 }
708
709 # stub; perf-lib overrides it
710 test_at_end_hook_ () {
711 :
712 }
713
714 test_done () {
715 GIT_EXIT_OK=t
716
717 if test -z "$HARNESS_ACTIVE"
718 then
719 test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
720 mkdir -p "$test_results_dir"
721 base=${0##*/}
722 test_results_path="$test_results_dir/${base%.sh}.counts"
723
724 cat >"$test_results_path" <<-EOF
725 total $test_count
726 success $test_success
727 fixed $test_fixed
728 broken $test_broken
729 failed $test_failure
730
731 EOF
732 fi
733
734 if test "$test_fixed" != 0
735 then
736 say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
737 fi
738 if test "$test_broken" != 0
739 then
740 say_color warn "# still have $test_broken known breakage(s)"
741 fi
742 if test "$test_broken" != 0 || test "$test_fixed" != 0
743 then
744 test_remaining=$(( $test_count - $test_broken - $test_fixed ))
745 msg="remaining $test_remaining test(s)"
746 else
747 test_remaining=$test_count
748 msg="$test_count test(s)"
749 fi
750 case "$test_failure" in
751 0)
752 if test $test_external_has_tap -eq 0
753 then
754 if test $test_remaining -gt 0
755 then
756 say_color pass "# passed all $msg"
757 fi
758
759 # Maybe print SKIP message
760 test -z "$skip_all" || skip_all="# SKIP $skip_all"
761 case "$test_count" in
762 0)
763 say "1..$test_count${skip_all:+ $skip_all}"
764 ;;
765 *)
766 test -z "$skip_all" ||
767 say_color warn "$skip_all"
768 say "1..$test_count"
769 ;;
770 esac
771 fi
772
773 if test -z "$debug"
774 then
775 test -d "$TRASH_DIRECTORY" ||
776 error "Tests passed but trash directory already removed before test cleanup; aborting"
777
778 cd "$TRASH_DIRECTORY/.." &&
779 rm -fr "$TRASH_DIRECTORY" ||
780 error "Tests passed but test cleanup failed; aborting"
781 fi
782 test_at_end_hook_
783
784 exit 0 ;;
785
786 *)
787 if test $test_external_has_tap -eq 0
788 then
789 say_color error "# failed $test_failure among $msg"
790 say "1..$test_count"
791 fi
792
793 exit 1 ;;
794
795 esac
796 }
797
798 if test -n "$valgrind"
799 then
800 make_symlink () {
801 test -h "$2" &&
802 test "$1" = "$(readlink "$2")" || {
803 # be super paranoid
804 if mkdir "$2".lock
805 then
806 rm -f "$2" &&
807 ln -s "$1" "$2" &&
808 rm -r "$2".lock
809 else
810 while test -d "$2".lock
811 do
812 say "Waiting for lock on $2."
813 sleep 1
814 done
815 fi
816 }
817 }
818
819 make_valgrind_symlink () {
820 # handle only executables, unless they are shell libraries that
821 # need to be in the exec-path.
822 test -x "$1" ||
823 test "# " = "$(head -c 2 <"$1")" ||
824 return;
825
826 base=$(basename "$1")
827 case "$base" in
828 test-*)
829 symlink_target="$GIT_BUILD_DIR/t/helper/$base"
830 ;;
831 *)
832 symlink_target="$GIT_BUILD_DIR/$base"
833 ;;
834 esac
835 # do not override scripts
836 if test -x "$symlink_target" &&
837 test ! -d "$symlink_target" &&
838 test "#!" != "$(head -c 2 < "$symlink_target")"
839 then
840 symlink_target=../valgrind.sh
841 fi
842 case "$base" in
843 *.sh|*.perl)
844 symlink_target=../unprocessed-script
845 esac
846 # create the link, or replace it if it is out of date
847 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
848 }
849
850 # override all git executables in TEST_DIRECTORY/..
851 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
852 mkdir -p "$GIT_VALGRIND"/bin
853 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/t/helper/test-*
854 do
855 make_valgrind_symlink $file
856 done
857 # special-case the mergetools loadables
858 make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
859 OLDIFS=$IFS
860 IFS=:
861 for path in $PATH
862 do
863 ls "$path"/git-* 2> /dev/null |
864 while read file
865 do
866 make_valgrind_symlink "$file"
867 done
868 done
869 IFS=$OLDIFS
870 PATH=$GIT_VALGRIND/bin:$PATH
871 GIT_EXEC_PATH=$GIT_VALGRIND/bin
872 export GIT_VALGRIND
873 GIT_VALGRIND_MODE="$valgrind"
874 export GIT_VALGRIND_MODE
875 GIT_VALGRIND_ENABLED=t
876 test -n "$valgrind_only" && GIT_VALGRIND_ENABLED=
877 export GIT_VALGRIND_ENABLED
878 elif test -n "$GIT_TEST_INSTALLED"
879 then
880 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
881 error "Cannot run git from $GIT_TEST_INSTALLED."
882 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
883 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
884 else # normal case, use ../bin-wrappers only unless $with_dashes:
885 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
886 if ! test -x "$git_bin_dir/git"
887 then
888 if test -z "$with_dashes"
889 then
890 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
891 fi
892 with_dashes=t
893 fi
894 PATH="$git_bin_dir:$PATH"
895 GIT_EXEC_PATH=$GIT_BUILD_DIR
896 if test -n "$with_dashes"
897 then
898 PATH="$GIT_BUILD_DIR:$PATH"
899 fi
900 fi
901 GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
902 GIT_CONFIG_NOSYSTEM=1
903 GIT_ATTR_NOSYSTEM=1
904 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
905
906 if test -z "$GIT_TEST_CMP"
907 then
908 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
909 then
910 GIT_TEST_CMP="$DIFF -c"
911 else
912 GIT_TEST_CMP="$DIFF -u"
913 fi
914 fi
915
916 GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
917 export GITPERLLIB
918 test -d "$GIT_BUILD_DIR"/templates/blt || {
919 error "You haven't built things yet, have you?"
920 }
921
922 if ! test -x "$GIT_BUILD_DIR"/t/helper/test-chmtime
923 then
924 echo >&2 'You need to build test-chmtime:'
925 echo >&2 'Run "make t/helper/test-chmtime" in the source (toplevel) directory'
926 exit 1
927 fi
928
929 # Test repository
930 TRASH_DIRECTORY="trash directory.$(basename "$0" .sh)"
931 test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
932 case "$TRASH_DIRECTORY" in
933 /*) ;; # absolute path is good
934 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
935 esac
936 rm -fr "$TRASH_DIRECTORY" || {
937 GIT_EXIT_OK=t
938 echo >&5 "FATAL: Cannot prepare test area"
939 exit 1
940 }
941
942 HOME="$TRASH_DIRECTORY"
943 GNUPGHOME="$HOME/gnupg-home-not-used"
944 export HOME GNUPGHOME
945
946 if test -z "$TEST_NO_CREATE_REPO"
947 then
948 test_create_repo "$TRASH_DIRECTORY"
949 else
950 mkdir -p "$TRASH_DIRECTORY"
951 fi
952 # Use -P to resolve symlinks in our working directory so that the cwd
953 # in subprocesses like git equals our $PWD (for pathname comparisons).
954 cd -P "$TRASH_DIRECTORY" || exit 1
955
956 this_test=${0##*/}
957 this_test=${this_test%%-*}
958 if match_pattern_list "$this_test" $GIT_SKIP_TESTS
959 then
960 say_color info >&3 "skipping test $this_test altogether"
961 skip_all="skip all tests in $this_test"
962 test_done
963 fi
964
965 # Provide an implementation of the 'yes' utility
966 yes () {
967 if test $# = 0
968 then
969 y=y
970 else
971 y="$*"
972 fi
973
974 i=0
975 while test $i -lt 99
976 do
977 echo "$y"
978 i=$(($i+1))
979 done
980 }
981
982 # Fix some commands on Windows
983 uname_s=$(uname -s)
984 case $uname_s in
985 *MINGW*)
986 # Windows has its own (incompatible) sort and find
987 sort () {
988 /usr/bin/sort "$@"
989 }
990 find () {
991 /usr/bin/find "$@"
992 }
993 # git sees Windows-style pwd
994 pwd () {
995 builtin pwd -W
996 }
997 # no POSIX permissions
998 # backslashes in pathspec are converted to '/'
999 # exec does not inherit the PID
1000 test_set_prereq MINGW
1001 test_set_prereq NATIVE_CRLF
1002 test_set_prereq SED_STRIPS_CR
1003 test_set_prereq GREP_STRIPS_CR
1004 GIT_TEST_CMP=mingw_test_cmp
1005 ;;
1006 *CYGWIN*)
1007 test_set_prereq POSIXPERM
1008 test_set_prereq EXECKEEPSPID
1009 test_set_prereq CYGWIN
1010 test_set_prereq SED_STRIPS_CR
1011 test_set_prereq GREP_STRIPS_CR
1012 ;;
1013 *)
1014 test_set_prereq POSIXPERM
1015 test_set_prereq BSLASHPSPEC
1016 test_set_prereq EXECKEEPSPID
1017 ;;
1018 esac
1019
1020 ( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
1021 test -z "$NO_PERL" && test_set_prereq PERL
1022 test -z "$NO_PTHREADS" && test_set_prereq PTHREADS
1023 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1024 test -n "$USE_LIBPCRE1$USE_LIBPCRE2" && test_set_prereq PCRE
1025 test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
1026
1027 # Can we rely on git's output in the C locale?
1028 if test -n "$GETTEXT_POISON"
1029 then
1030 GIT_GETTEXT_POISON=YesPlease
1031 export GIT_GETTEXT_POISON
1032 test_set_prereq GETTEXT_POISON
1033 else
1034 test_set_prereq C_LOCALE_OUTPUT
1035 fi
1036
1037 # Use this instead of test_cmp to compare files that contain expected and
1038 # actual output from git commands that can be translated. When running
1039 # under GETTEXT_POISON this pretends that the command produced expected
1040 # results.
1041 test_i18ncmp () {
1042 test -n "$GETTEXT_POISON" || test_cmp "$@"
1043 }
1044
1045 # Use this instead of "grep expected-string actual" to see if the
1046 # output from a git command that can be translated either contains an
1047 # expected string, or does not contain an unwanted one. When running
1048 # under GETTEXT_POISON this pretends that the command produced expected
1049 # results.
1050 test_i18ngrep () {
1051 if test -n "$GETTEXT_POISON"
1052 then
1053 : # pretend success
1054 elif test "x!" = "x$1"
1055 then
1056 shift
1057 ! grep "$@"
1058 else
1059 grep "$@"
1060 fi
1061 }
1062
1063 test_lazy_prereq PIPE '
1064 # test whether the filesystem supports FIFOs
1065 case $(uname -s) in
1066 CYGWIN*|MINGW*)
1067 false
1068 ;;
1069 *)
1070 rm -f testfifo && mkfifo testfifo
1071 ;;
1072 esac
1073 '
1074
1075 test_lazy_prereq SYMLINKS '
1076 # test whether the filesystem supports symbolic links
1077 ln -s x y && test -h y
1078 '
1079
1080 test_lazy_prereq FILEMODE '
1081 test "$(git config --bool core.filemode)" = true
1082 '
1083
1084 test_lazy_prereq CASE_INSENSITIVE_FS '
1085 echo good >CamelCase &&
1086 echo bad >camelcase &&
1087 test "$(cat CamelCase)" != good
1088 '
1089
1090 test_lazy_prereq UTF8_NFD_TO_NFC '
1091 # check whether FS converts nfd unicode to nfc
1092 auml=$(printf "\303\244")
1093 aumlcdiar=$(printf "\141\314\210")
1094 >"$auml" &&
1095 case "$(echo *)" in
1096 "$aumlcdiar")
1097 true ;;
1098 *)
1099 false ;;
1100 esac
1101 '
1102
1103 test_lazy_prereq AUTOIDENT '
1104 sane_unset GIT_AUTHOR_NAME &&
1105 sane_unset GIT_AUTHOR_EMAIL &&
1106 git var GIT_AUTHOR_IDENT
1107 '
1108
1109 test_lazy_prereq EXPENSIVE '
1110 test -n "$GIT_TEST_LONG"
1111 '
1112
1113 test_lazy_prereq USR_BIN_TIME '
1114 test -x /usr/bin/time
1115 '
1116
1117 test_lazy_prereq NOT_ROOT '
1118 uid=$(id -u) &&
1119 test "$uid" != 0
1120 '
1121
1122 test_lazy_prereq JGIT '
1123 type jgit
1124 '
1125
1126 # SANITY is about "can you correctly predict what the filesystem would
1127 # do by only looking at the permission bits of the files and
1128 # directories?" A typical example of !SANITY is running the test
1129 # suite as root, where a test may expect "chmod -r file && cat file"
1130 # to fail because file is supposed to be unreadable after a successful
1131 # chmod. In an environment (i.e. combination of what filesystem is
1132 # being used and who is running the tests) that lacks SANITY, you may
1133 # be able to delete or create a file when the containing directory
1134 # doesn't have write permissions, or access a file even if the
1135 # containing directory doesn't have read or execute permissions.
1136
1137 test_lazy_prereq SANITY '
1138 mkdir SANETESTD.1 SANETESTD.2 &&
1139
1140 chmod +w SANETESTD.1 SANETESTD.2 &&
1141 >SANETESTD.1/x 2>SANETESTD.2/x &&
1142 chmod -w SANETESTD.1 &&
1143 chmod -r SANETESTD.1/x &&
1144 chmod -rx SANETESTD.2 ||
1145 error "bug in test sript: cannot prepare SANETESTD"
1146
1147 ! test -r SANETESTD.1/x &&
1148 ! rm SANETESTD.1/x && ! test -f SANETESTD.2/x
1149 status=$?
1150
1151 chmod +rwx SANETESTD.1 SANETESTD.2 &&
1152 rm -rf SANETESTD.1 SANETESTD.2 ||
1153 error "bug in test sript: cannot clean SANETESTD"
1154 return $status
1155 '
1156
1157 test FreeBSD != $uname_s || GIT_UNZIP=${GIT_UNZIP:-/usr/local/bin/unzip}
1158 GIT_UNZIP=${GIT_UNZIP:-unzip}
1159 test_lazy_prereq UNZIP '
1160 "$GIT_UNZIP" -v
1161 test $? -ne 127
1162 '
1163
1164 run_with_limited_cmdline () {
1165 (ulimit -s 128 && "$@")
1166 }
1167
1168 test_lazy_prereq CMDLINE_LIMIT 'run_with_limited_cmdline true'
1169
1170 build_option () {
1171 git version --build-options |
1172 sed -ne "s/^$1: //p"
1173 }
1174
1175 test_lazy_prereq LONG_IS_64BIT '
1176 test 8 -le "$(build_option sizeof-long)"
1177 '
1178
1179 test_lazy_prereq TIME_IS_64BIT 'test-date is64bit'
1180 test_lazy_prereq TIME_T_IS_64BIT 'test-date time_t-is64bit'